﻿
#ifndef BASECONNECTION_H
#define BASECONNECTION_H


#include <QObject>
#include <QMap>

class BaseConnection : public QObject
{
    Q_OBJECT
public:
    explicit BaseConnection(QObject *parent = nullptr);
    QString getProtocol();
    QMap<QString,QString> getParas();
    QString getConnectionName();
    virtual void setting(QMap<QString,QString> &map);
    virtual bool isConnected() = 0;
    virtual bool open() = 0;
    virtual bool close() = 0;
    virtual int sendData(const QByteArray &data) = 0;

signals:
    void recvDataSignal(const QByteArray &data);
    void recvUserSendDataSignal(const QByteArray &data);
    void connectionStatusChangeSignal(bool bconnected);

protected:
    QString protocol;
    QMap<QString,QString> paras;
    QString connectionName;
};

#endif // BASECONNECTION_H
