﻿#ifndef MUTILSERIALCONFIGWIDGET_H
#define MUTILSERIALCONFIGWIDGET_H

#include <QWidget>
#include <QMap>
#include "connectionSettingWidget.h"

namespace Ui {
class MutilSerialConfigWidget;
}

class MutilSerialConfigWidget : public QWidget
{
    Q_OBJECT

public:
    explicit MutilSerialConfigWidget(QWidget *parent = nullptr);
    ~MutilSerialConfigWidget();

private slots:
    void receiverDataHandle(const QByteArray &data);
    void displayHexHandle();
    void displayAsciiHandle();
    void displayClearHandle();
    void displayStopHandle();
    void on_toolBtnAddLeft_clicked();
    void on_toolBtnAddRight_clicked();
    void on_plainTextEdit_customContextMenuRequested(const QPoint &pos);

private:
    Ui::MutilSerialConfigWidget *ui;
    QMap<ConnectionSettingWidget*,QPair<int,int>> wdgLeftMap;
    QMap<ConnectionSettingWidget*,QPair<int,int>> wdgRightMap;
    bool bdisplayHex=false;
    bool bStop=false;
};

#endif // MUTILSERIALCONFIGWIDGET_H
