﻿#ifndef SERIALCONFIGWIDGET_H
#define SERIALCONFIGWIDGET_H

#include <QWidget>
#include <QMutex>
#include <cstring>
#include "CSerialPort/SerialPort.h"

using namespace itas109;

namespace Ui {
class SerialConfigWidget;
}

class SerialConfigWidget : public QWidget ,public CSerialPortListener
{
    Q_OBJECT

public:
    explicit SerialConfigWidget(QWidget *parent = nullptr);
    ~SerialConfigWidget();

signals:
    void displayTextSignal(const QString &txt);

private slots:
    void on_toolBtnRefresh_clicked();
    void on_toolBtnOk_clicked();
    void displayText(const QString &txt);

private slots:
    void onReadEvent(const char *portName, unsigned int readBufferLen) override;

private:
    Ui::SerialConfigWidget *ui;
    CSerialPort m_SerialPort1,m_SerialPort2;
    int readIntervalTimeoutMS = 50;
    QMutex mtx;
    void refreshCom();
};

#endif // SERIALCONFIGWIDGET_H
